import com.dynamicflash.utils.Delegate;
import com.kelvinluck.util.DrawTools;
/**
* Class: BasicButton
* Very basic button class - useful for prototyping applications where you
* want to be able to distribute the code (e.g. not using other peoples 
* components) or for applications with no fla or library.
* 
* Author:
* Kelvin Luck
**/
class com.kelvinluck.util.BasicButton 
{
	var COLOUR_OFF:Number = 0xdddddd;
	var COLOUR_ROLL:Number = 0xaaaaaaa;
	var mc:MovieClip;
	var bg:MovieClip;
	var bgColour:Color;
	
	/**
	* Function: BasicButton
	* Constructor
	**/
	function BasicButton(target:MovieClip, instanceName:String, depth:Number, label:String, initObject:Object)
	{
		mc = target.createEmptyMovieClip(instanceName, depth);
		if (initObject) {
			for (var prop:String in initObject) {
				mc[prop]= initObject[prop];
			}
		}
		bg = mc.createEmptyMovieClip("bg", 1);
		mc.createTextField("label", 2, 10, 5, 10, 10);
		mc.label.autoSize = true;
		mc.label.setNewTextFormat(new TextFormat("arial"));
		mc.label.text = label;
		DrawTools.drawRectangle(bg, 0, 0, mc.label._width+20, mc.label._height+10, COLOUR_OFF);
		bgColour = new Color(bg);
		
		
		mc.onRollOver = Delegate.create(this, onRollOver);
		mc.onRollOut = Delegate.create(this, onRollOut);
		mc.onRelease = Delegate.create(this, onRelease);
	}
	
	/**
	* Function: onRelease
	* Called when the button is rolled over
	**/
	function onRelease()
	{
		// because of the Delegate above this function still exists to be called even though you should
		// have assigned another function to onRelease which is what we call below...
		onRelease();
	}
	/**
	* Function: onRollOut
	* Called when the button is rolled over
	**/
	function onRollOut()
	{
		bgColour.setRGB(COLOUR_OFF);
	}
	/**
	* Function: onRollOver
	* Called when the button is rolled over
	**/
	function onRollOver()
	{
		bgColour.setRGB(COLOUR_ROLL);
	}
	/**
	* Function: toString
	**/
	public function toString():String
	{
		return "[com.kelvinluck.util.BasicButton]";
	}
}